var c = document.getElementById('c'),
    link = document.createElement('a'),
    ctx = c.getContext('2d'),
    last = {x: null, y: null},
    current = {x: null, y: null},
    drawing = false, isMirror = true,
    cx, cy, r, angle, _2PI = 2*Math.PI,
    s = { 
        '画笔个数': 6,
        '画笔粗细': 2,
        '背景颜色': '#000',
        '画笔颜色': '#f00',
        'mirror': true,
        '清除重来': function() {
            resize();
			alert('over_cn')
			alert('over_cn')
        },
        '分享作品': function() {
            //link.click();
			alert('over_cn')
			alert('over_cn')
			alert('share')
        }
    };

link.addEventListener('click', function() {
    link.href = c.toDataURL();
    link.download = "mandala.png";
});
document.body.appendChild(link);

function resize() {
    c.width = window.innerWidth;
    c.height = window.innerHeight;
    cx = c.width/2;
    cy = c.height/2;
    r = Math.min(cx, cy) - 4;
    angle = _2PI/s.画笔个数;
    drawSectors();  
    ctx.translate(cx, cy);
}
resize();
window.addEventListener("resize", resize);

var gui = new dat.GUI(),
    col = gui.addFolder('\u8272\u5f69\u9009\u62e9');

col.addColor(s, "背景颜色").onChange(resize);
col.addColor(s, "画笔颜色");
gui.add(s, "画笔个数", 2, 20, 1).onChange(resize);
gui.add(s, "画笔粗细", 1, 10, 1);
gui.add(s, "mirror").onChange(function() {
    isMirror = !isMirror;
});
gui.add(s, "清除重来");
gui.add(s, "分享作品");

function drawSectors() {
    ctx.fillStyle = s.背景颜色;
    ctx.arc(cx, cy, r, 0, _2PI);
    ctx.fill();
    
    for(var i=0; i<_2PI; i+=angle) {
        ctx.beginPath();
        ctx.lineWidth = 1;
        ctx.strokeStyle = 'rgba(211, 211, 211, .15)';
        ctx.moveTo(cx, cy);
        ctx.arc(cx, cy, r, i, i + angle);
        ctx.lineTo(cx, cy);
        ctx.stroke();
    }
}

function d(x1, y1, x2, y2) {
    return Math.sqrt(
        Math.pow(x1-x2, 2) + Math.pow(y1-y2, 2)
    );
}

function reset() {
    drawing = false;
    last.x = null;
    last.y = null;
}

function draw(e) {
    if(drawing) {
        var x = e.touches ? e.touches[0].clientX : e.clientX,
            y = e.touches ? e.touches[0].clientY : e.clientY;

        x-= c.offsetLeft;
        y-= c.offsetTop;
        
        if(d(x, y, cx, cy) < r) {
            current.x = x - cx;
            current.y = y - cy;
            drawLine();
        } else {
            reset();
        }
    }    
}

c.addEventListener('mousedown', function() {
    drawing = true;
});

c.addEventListener('touchstart', function() {
    drawing = true;
});

c.addEventListener('mousemove', draw);
c.addEventListener('touchmove', draw);

c.addEventListener('mouseup', reset);
c.addEventListener('touchend', reset);

function drawLine() {
    ctx.lineWidth = s['画笔粗细'];
    ctx.lineCap = 'round';
    ctx.strokeStyle = s.画笔颜色;
    
    for(var i=0; i<_2PI; i+=angle) {
        ctx.rotate(angle);
        if(last.x != null && last.y != null) {
            ctx.beginPath();
            ctx.moveTo(last.x, last.y);
            ctx.lineTo(current.x, current.y);
            if (isMirror) {
                ctx.moveTo(-last.x, last.y);
                ctx.lineTo(-current.x, current.y);          
            }
            ctx.stroke();
        }
    }
    last.x = current.x;
    last.y = current.y;
}
